<template>
  <rui-dropdown :caption="$t('js.stroke_style_presets.line_style')" block select-like>
    <template v-if="selected" #caption>
      <div>
        <svg v-bind="svgAttributes">
          <line v-bind="lineAttributes"
                :style="strokeStylePresets[selected].style(width)" />
        </svg>
        {{ $t(strokeStylePresets[selected].i18n) }}
      </div>
    </template>
    <rui-menu-item v-for="(preset, key) in strokeStylePresets"
                   :key="key"
                   @click="select(key)">
      <div>
        <svg v-bind="svgAttributes">
          <line v-bind="lineAttributes"
                :style="preset.style(width)" />
        </svg>
        {{ $t(preset.i18n) }}
      </div>
    </rui-menu-item>
  </rui-dropdown>
</template>

<script>
import RuiDropdown from '@experiments-labs/rise_ui/src/components/Dropdown/Dropdown.vue'
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'

import strokeStylePresets from '../../../../strokeStylePresets'

export default {
  name: 'GpaPathStrokeStylePresets',
  emits: [
    'choose',
  ],
  components: { RuiMenuItem, RuiDropdown },
  props: {
    width: { required: true, type: Number },
    selected: { required: false, type: String, default: 'default' },
  },
  data () {
    return {
      strokeStylePresets,
      lineAttributes: {
        x1: '5',
        x2: '45',
        y1: '7',
        y2: '7',
        stroke: 'black',
      },
      svgAttributes: {
        xmlns: 'http://www.w3.org/2000/svg',
        width: '50',
        height: '15',
        viewBox: '0 0 50 15',
        class: '-checked-background',
      },
    }
  },
  methods: {
    select (preset) { this.$emit('choose', preset) },
  },
}
</script>
